 ;									     ;
 ;				   OSL API				     ;
 ;	      Interface between the OSLm i386 Kernel and the System	     ;
 ;									     ;

Ideal		; Quit Microsoftish things as soon as possible
%NOLIST		; do not include in listing...
if 0		; preliminary notes

Done:		Nothing.
Being done:	Everything.
To Do:		Everything.

Specifications:

A) Goals:
- Define a unified low-level standard for OSL's API, independently from
the OS used (a DOS extender, Windows, OS/2, Linux, MOOSE)

B) Constraints:
  Can be loaded anywhere. Code outside the API must not depend on either
paging or segmenting.

endif

;;;;;;;;;;;;;;;;;;;;;;;; COMPILATION DIRECTIVES ;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; Listinf directives
%noctls
%noincl
%noconds
;%nocref
%nomacs
;%syms
;%notrunc

P386	; of course ! (allow protected mode)

Include "../macro.inc"	; Macros
Include "../mem386.inc"

%list	; let's go

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; Define segments ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Masm	;;; Ensure that segments will be ordered in their appearing order
.SEQ
Ideal

Group	APIHeader	HeaderBinary, HeaderStrings
Group   OSLmAPI		APICode, GlobAPIData, APIInitCode
Assume	cs:OSLmAPI,ds:OSLmAPI,es:OSLmAPI,ss:OSLmAPI
Assume  fs:OSLmAPI,gs:OSLmAPI

Segment HeaderBinary	para public use32 'API'
EndS
Segment HeaderStrings	byte  public use32 'API'
EndS

Segment APICode	para  public use32 'API'
EndS
Segment GlobAPIData	dword public use32 'API'
EndS
Segment APIInitCode	byte  public use32 'API'
EndS


;;; Public definitions should allow (with a public map file)
;;; external programs to get the entry points rights.
public	APIInitJumpPoint, TotalAPIFileLength
public	BeginningOfGAPIData, APIOffset

End
