Segment KernelCode
  KernelOffset		=	$


;; Minimal instruction set for a FORTH-like machine...

	CSTK_ADD:
			mov eax,[esi]
			add esi,4
			add [esi],eax
			ret
	CSTK_SUB:
			mov eax,[esi]
			add esi,4
			sub [esi],eax
			ret
	CSTK_SHR:
			shr [dword esi],1
			ret
	CSTK_STO:
			mov ebx,[esi]
			mov eax,[esi+4]
			add esi,8
			mov [eax]
			ret
	CSTK_LOD:
			mov ebx,[esi]
			mov eax,[esi+4]
			add esi,8
			mov [eax]
			ret
	CSTK_IMM:
			sub esi,4
			pop [esi]
			ret
	CSTK_BZR:
	CSTK_JMP:
	CSTK_

	EXEC_MANY:
	;; executes ECX kernel instructions pointed at by EBX
			xchg ebx,esi
			mov edx,edi
			lea eax,[ecx*4]
			sub esp,eax
			mov eax,[ebx]
			@REPEAT
			  push eax
			  add ebx,4
			  mov eax,[ebx]
			  or eax,eax
			@UNTIL z
			ret

EndS
