/* Include system headers */

#include <stdio.h>	/* Stream I/O et formatted I/O */
#include <stdlib.h>	/* STD C calls */
#include <string.h>	/* Strings */
#include <malloc.h>	/* malloc */
#include <sys/types.h>	/* system types */

#if defined(linux)
 /* nothing left here */
#endif

#include <signal.h>	/* signal handling */


#if   defined(_PROCESS_0)
#  define PROC_MSG	"init"
#elif defined(_PROCESS_1)
#  define PROC_MSG	"sys"
#elif defined(_PROCESS_2)
#  define PROC_MSG	"run"
#elif defined(_PROCESS_3)
#  define PROC_MSG	"time"
#endif

#include "../CLibs/DebugC.h"
#include "limits.h"

#define ___(n,x...) DBGMSG(n,PROC_MSG " " __FILE__ ": " x)
